{/*
   UPuissance4GetGameResult.pas

   DATE   : 07/01/2007
   NOTE   : Cette unit englobe les procdures ncssaires pour savoir l'tat de la partie
   AUTEUR : KHELIL RADOUANE ABDESSALAM
   EMAIL  : rkhelil@gmail.com
*/}
UNIT UPuissance4GetGameResult;

INTERFACE

TYPE
  // Element pour parcourir une diagonale

  TDiagData = Record
                X,Y       : Integer; // Dbut de la diagonale coordonnes dans aGame
                IncX,IncY : Integer; // Valeurs des incrmentations
                Len       : Integer; // Longeur de la diagonale
              End;


  // Etat de la partie
  TGameResult = ( grGameInProgress , grNoWinner , grPlayer1Win , grPlayer2Win );

      Function  GetGameResult:TGameResult;

IMPLEMENTATION

Uses UPuissance4Globals;

CONST
  // Tableau constant pour le parcours des diagonales

  aDiagonals : Array[1..12] Of TDiagData = ( (X:1;Y:4;IncX:1;IncY:-1;Len:4) ,
                                             (X:1;Y:5;IncX:1;IncY:-1;Len:5) ,
                                             (X:1;Y:6;IncX:1;IncY:-1;Len:6) ,
                                             (X:2;Y:6;IncX:1;IncY:-1;Len:6) ,
                                             (X:3;Y:6;IncX:1;IncY:-1;Len:5) ,
                                             (X:4;Y:6;IncX:1;IncY:-1;Len:4) ,
                                             (X:1;Y:3;IncX:1;IncY:1;Len:4) ,
                                             (X:1;Y:2;IncX:1;IncY:1;Len:5) ,
                                             (X:1;Y:1;IncX:1;IncY:1;Len:6) ,
                                             (X:2;Y:1;IncX:1;IncY:1;Len:6) ,
                                             (X:3;Y:1;IncX:1;IncY:1;Len:5) ,
                                             (X:4;Y:1;IncX:1;IncY:1;Len:4) );


{/*
   Cette fonction teste si 4 jetons de mme couleur se trouve dans la diagonale nDiagonal
   et retourne cette couleur.
*/}
Function TestDiagonal( nDiagonal : Byte ; Var Cell : TCellState ):Boolean;
Var
  I,nCount : Integer;
  WCell    : TCellState;
  DD       : TDiagData;  // Diagonal infos
Begin
  WCell  := csEmpty;
  nCount := 0;
  DD := aDiagonals[nDiagonal];
  I  := 1;
  While ( I <= DD.Len ) And ( nCount < 4 ) Do
  Begin
    IF (aGame[DD.X,DD.Y] <> csEmpty) Then
    Begin
      IF (aGame[DD.X,DD.Y] <> WCell) Then
      Begin
        WCell  := aGame[DD.X,DD.Y];
        nCount := 1;
      End
      Else
        Inc(nCount);
    End
    Else
      nCount := 0;

    Inc(I);
    // Prochain lment de la diagonale
    Inc( DD.X , DD.IncX );
    Inc( DD.Y , DD.IncY );
  End;

  Cell   := WCell;
  Result := (nCount=4);
End;

{/*
   Cette fonction teste si 4 jetons de mme couleur se trouve dans la ligne nLine
   et retourne cette couleur.
*/}
Function TestLine( nLine : Byte ; Var Cell : TCellState ):Boolean;
Var
  I,nCount : Integer;
  WCell    : TCellState;
Begin
  WCell  := csEmpty;
  nCount := 0;

  I:=1;
  While ( I <= MAX_COL ) And ( nCount < 4 ) Do
  Begin
    IF (aGame[I,nLine] <> csEmpty) Then
    Begin
      IF (aGame[I,nLine] <> WCell) Then
      Begin
        WCell  := aGame[I,nLine];
        nCount := 1;
      End
      Else
        Inc(nCount);
    End
    Else
      nCount := 0;
    Inc(I);
  End;

  Cell   := WCell;
  Result := (nCount=4);
End;

{/*
   Cette fonction teste si 4 jetons de mme couleur se trouve dans la colonne nColumn
   et retourne cette couleur.
*/}
Function TestColumn( nColumn : Byte ; Var Cell : TCellState ):Boolean;
Var
  I,nCount : Integer;
  WCell    : TCellState;
Begin
  WCell  := csEmpty;
  nCount := 0;

  I:=1;
  While ( I <= MAX_LIN ) And ( nCount < 4 ) Do
  Begin
    IF (aGame[nColumn,I] <> csEmpty) Then
    Begin
      IF (aGame[nColumn,I] <> WCell) Then
      Begin
        WCell  := aGame[nColumn,I];
        nCount := 1;
      End
      Else
        Inc(nCount);
    End
    Else
      nCount := 0;
    Inc(I);
  End;

  Cell   := WCell;
  Result := (nCount=4);
End;


{/*
    Cette fonction retourne l'tat de la partie:
    grGameInProgress : partie non termine
    grNoWinner       : partie termine mais aucun vainqueur (partie nulle)
    grPlayer1Win     : partie termine et gagne par le joueur 1
    grPlayer2Win     : partie termine et gagne par le joueur 2
*/}
Function  GetGameResult:TGameResult;
Var
  nIdx   : Integer;
  bFound : Boolean;
  Who    : TCellState;
Begin
  Result := grGameInProgress;

  nIdx   := 1;
  bFound := FALSE;
  // Voir si 4 jetons sont de mme couleur dans une ligne
  While ( nIdx <= MAX_LIN ) And Not(bFound) Do
  Begin
    bFound := TestLine( nIdx , Who );
    Inc(nIdx);
  End;

  // Sinon voir si 4 jetons sont de mme couleur dans une colonne
  IF NOT( bFound ) Then
  Begin
    nIdx   := 1;
    While ( nIdx <= MAX_COL ) And Not(bFound) Do
    Begin
      bFound := TestColumn( nIdx , Who );
      Inc(nIdx);
    End;
  End;

  // Sinon voir si 4 jetons sont de mme couleur dans une diagonale
  IF NOT( bFound ) Then
  Begin
    nIdx   := 1;
    While ( nIdx <= 12 ) And Not(bFound) Do
    Begin
      bFound := TestDiagonal( nIdx , Who );
      Inc(nIdx);
    End;
  End;

  // Retourne l'tat de la partie.
  IF bFound Then
  Begin
    Case Who Of
         csWhite : Result := grPlayer1Win;
         csBlack : Result := grPlayer2Win;
    End;
  End
  Else
  Begin
    IF ( nBalls1 = 0 ) And ( nBalls2 = 0 ) Then
       Result := grNoWinner
    Else
       Result := grGameInProgress;
  End;
End;

END.
